----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    14:02:49 11/15/2013 
-- Design Name: 
-- Module Name:    boundscan - Structural 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity boundscan is
    Port ( Din0 : in  STD_LOGIC;
           Din1 : in  STD_LOGIC;
           Din2 : in  STD_LOGIC;
           Din3 : in  STD_LOGIC;
           Scan_en : in  STD_LOGIC;
           Scan_in : in  STD_LOGIC;
           clk : in  STD_LOGIC;
           Dout0 : out  STD_LOGIC;
           Dout1 : out  STD_LOGIC;
           Dout2 : out  STD_LOGIC;
           Dout3 : out  STD_LOGIC;
           Scan_out : out  STD_LOGIC);
end boundscan;

architecture Structural of boundscan is


component fm is
Port    (  Din : in  STD_LOGIC;
           Scan_in : in  STD_LOGIC;
           Scan_en : in  STD_LOGIC;
           clk : in  STD_LOGIC;
           Dout : out  STD_LOGIC);
end component;

signal u0,u1,u2,u3 : STD_LOGIC;

begin

flimux1 : fm Port Map(Din0,Scan_in,Scan_en,clk,u0);
flimux2 : fm Port Map(Din1,u0,Scan_en,clk,u1);
flimux3 : fm Port Map(Din2,u1,Scan_en,clk,u2);
flimux4 : fm Port Map(Din3,u2,Scan_en,clk,u3);


logica : process(Din0,Din1,Din2,Din3,Scan_in,clk,Scan_en)

begin
	
	if Scan_en='0'
	then
			 Dout0 <= Din0;
			 Dout1 <= Din1;
			 Dout2 <= Din2;
			 Dout3 <= Din3;
			else
			Scan_out <= Din0;
			
	end if;

end process;

end Structural;

