----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    17:22:02 11/15/2013 
-- Design Name: 
-- Module Name:    Sommatore - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity Sommatore is
    Port ( In0 : in  STD_LOGIC;
           In1 : in  STD_LOGIC;
           In2 : in  STD_LOGIC;
           In3 : in  STD_LOGIC;
           O0 : out  STD_LOGIC;
           O1 : out  STD_LOGIC;
           O2 : out  STD_LOGIC;
           O3 : out  STD_LOGIC);
end Sommatore;

architecture Structural of Sommatore is

component boundscan is
Port    (   Din0 : in  STD_LOGIC;
           Din1 : in  STD_LOGIC;
           Din2 : in  STD_LOGIC;
           Din3 : in  STD_LOGIC;
           Scan_en : in  STD_LOGIC;
           Scan_in : in  STD_LOGIC;
           clk : in  STD_LOGIC;
           Dout0 : out  STD_LOGIC;
           Dout1 : out  STD_LOGIC;
           Dout2 : out  STD_LOGIC;
           Dout3 : out  STD_LOGIC;
           Scan_out : out  STD_LOGIC);
end component;

begin

In0 <= Dout0;
In1 <= Dout1;
In2 <= Dout2;
In3 <= Dout3;
 
O0 <= In0;
O1 <= In1;
O2 <= In2;
O3 <= In3 OR '1';

end Structural;

