----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    13:29:19 11/15/2013 
-- Design Name: 
-- Module Name:    fm - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity fm is
    Port ( Din : in  STD_LOGIC;
           Scan_in : in  STD_LOGIC;
           Scan_en : in  STD_LOGIC;
           clk : in  STD_LOGIC;
           Dout : out  STD_LOGIC);
end fm;


architecture Structural of fm is

--Definizione del Componente Flip-Flop
-------------------------------------
component flip_flop is
	Port ( d : in  STD_LOGIC;
          clock : in  STD_LOGIC;
          q : out  STD_LOGIC);
end component;
-------------------------------------

--Definizione del Componente Mux2-1
-------------------------------------
component mux2_1 is 
	Port ( a : in  STD_LOGIC;
          b : in  STD_LOGIC;
          sel : in  STD_LOGIC;
          o : out  STD_LOGIC);
end component;
-------------------------------------
signal temp : STD_LOGIC;

begin
--Port Map dei componenti

mux : mux2_1 port map(Din, Scan_in, Scan_en, temp);	
ff : flip_flop port map(temp, clk, Dout);	

end Structural;

